#!/bin/bash
#######################################################################
#  Script que faz a verificacao nos pontos de montagens existentes e
#  informa se os mesmos estao em Read Write ou nao,
#  informando status CRITICAL caso nao estejam em RW.
#  Exemplo de execucao do script: [script.sh] [ponto-de-montagem]
#
#  Realizado ajuste no plugin, a verificação se dá atrávés do comando /proc/mouts
#  O mesmo verifica a existencia da opção 'ro' (Read-Only)
#
# Criado em: 08/09/2016 por Wagner Garcez
# Versão 2 : 27/03/2017 por Wagner Garcez
########################################################################

DIR="$1"  # Ponto de montagem

if [ $# -lt 1 ]; then
    echo "UNKNOWN - Missing arguments: $0 [mount point]"
    exit 3
  fi

if cat /proc/mounts | awk '{print $2}' | grep "^$DIR$" &> /dev/null; then
        if  cat /proc/mounts | grep "$DIR " | awk '{print $4}' | grep "^ro" > /dev/null; then
                status=1
                echo "CRITICAL: Mounting point $DIR is available but Read-Only. | status=$status;;;;"
                exit 2
        else
                status=0
                echo "OK: Mounting point $DIR is available and Writable. | status=$status;;;;"
                exit 0
        fi
else
        echo "UNKNOWN: $DIR ins't mounted or doesn't exist."
        exit 3
fi
