#!/usr/bin/php -q
<?php

function main() {
	$arg = get_options();
	$host = $arg['H'];
	$mode = $arg['m'];
	$verbose = $arg['v'];

	//Buscar array de nameservers principal de acordo com o a web
	$arr_nameserver_as_web = getNameserversByExternal($host, $verbose);
	//var_dump($arr_nameserver_as_web);
	//$arr_nameserver_as_web[] = 'a.dns.br';
	$result_auth = verifyAuthoritative($host, $arr_nameserver_as_web, $verbose);

	//var_dump($result_auth);
	//$arr_soa = array_keys($result_auth);
	//exit;

	switch ($mode) {
		case 'a':
			quit_auth($result_auth);
			break;
		case 's':
			verifySoa($host, $result_auth, $verbose);
			break;
		case 'r':
			verifyParent($host, $arr_nameserver_as_web, $result_auth);
			break;
		case 'n':
			verify2NS($arr_nameserver_as_web);
			break;
		default:
			quit_auth($result_auth);
			break;
	}
	quit("Unknown", 3);	
}	

/**** Functions ****/
function verify2NS($arr){
	$n = count($arr);
	if ($n >= 2 ) {
		$msg = "Nameservers OK - ".implode(";", $arr);
		$code = 0;

	}else{
		$msg = "Nameservers < 2 - ".implode(";", $arr);
		$code = 2;
	}
	quit($msg, $code);

}

function verifyParent($host, $arr_nameserver_as_web, $result_auth){
	/*var_dump("externo");
	var_dump($arr_nameserver_as_web);

	var_dump("auth");*/
	//$arr_nameserver_as_web[] =  "nsfr2.interop.com.br.";
	//$result_auth["nsfr.interop.com.br."]["nameservers"][] =  "nsfr3.interop.com.br.";
	//var_dump($result_auth);
	//exit;
	$arr_erros = array();
	foreach ($result_auth as $key => $value) {
		//var_dump($arr_nameserver_as_web);
		$arr_diff1 = array_diff(  $arr_nameserver_as_web, $value['nameservers']);
		$arr_diff2 = array_diff( $value['nameservers'], $arr_nameserver_as_web);
		if (count($arr_diff1 > 0)) {
			$arr_erros = array_merge($arr_erros, $arr_diff1);
		}

		if (count($arr_diff2 > 0)) {
			$arr_erros = array_merge($arr_erros, $arr_diff2);
		}
		//var_dump($value['nameservers']);
		
	}
	$arr_erros = array_unique($arr_erros);
	//var_dump($arr_erros);
	$total_erros = 0;
	if(count($arr_erros) > 0){

		$msg = "Nameservers Inconsistent - ".implode(";", $arr_erros);
		$code = 2;
		$total_erros = count($arr_erros);

	}else{
		$msg = "Nameservers without inconsistencies ";
		$code = 0;
	}
	quit($msg." | 'total_erros'=".$total_erros.";;;0; ", $code);
}

function quit_auth($result_auth){
	$erro = 0;
	$msg_erro = "";
	$msg = "";
	$total_time = 0;
	$perf = " | 'total_time'=0;;;0; ";
	foreach ($result_auth as $key => $value) {
		if($value['code'] != 0){
			$erro = 2;
			$msg_erro .= $key." / ";
		}else{
			$time = round($value['time'], 4);
			$total_time = $total_time + $time;
			$msg .= $key."=".$time ." / ";
			$perf =" | 'total_time'=".$total_time.";;;0; ";
		} 
	}
	
	$exit_code = 3;
	if ($erro != 0) {
		$mensagem = "NS Not authoritative - ".$msg_erro." | 'total_time'=0;;;0; ";
		$exit_code = 2;
	}else{
		$mensagem = "NS Authoritative - ".$msg.$perf;
		$exit_code = 0;
	}
	$mensagem = str_replace(" /  ", " ", $mensagem);
	quit($mensagem, $exit_code);

}

function verifyAuthoritative($host, $arr_nameserver_as_web, $dd=null){
	//valida nameservers se são autoritativo
	//$arr_nameserver_as_web[] = 'nsoi.com.br';
	//$arr_nameserver_as_web[] ="nsfr2.interop.com.br.";

	$arr_ns_result = check_arr_dns_authoritative($host, $arr_nameserver_as_web,$dd);
	 if(isset($dd))  var_dump($arr_ns_result);

	$arr_ns = array();
	foreach ($arr_ns_result as $key => $value) {
		//var_dump($value['nameservers']);
		$arr_ns = array_merge($arr_ns, $value['nameservers'] );
	}

	$arr_ns = array_unique($arr_ns);
	$ns_a_checar = array_diff( $arr_ns ,$arr_nameserver_as_web);
	//var_dump(count($ns_a_checar));
	if(count($ns_a_checar) > 0){
		$ns_checado = check_arr_dns_authoritative($host, $ns_a_checar);
		//var_dump($arr_ns_result);		//var_dump($ns_checado);
		$arr_ns_result_final = array_merge($arr_ns_result, $ns_checado );
	}else{
		$arr_ns_result_final = $arr_ns_result;
	}
	//var_dump($arr_ns_result_final);
	return $arr_ns_result_final;
}

function check_arr_dns_authoritative($host, $arr, $dd){
	foreach ($arr as $server_zone) {
		$arr_check_auth[$server_zone] = check_dns_authoritative($host, $server_zone, $dd);
	}
	return $arr_check_auth;
}


function check_dns_authoritative($host, $server_zone, $dd=null){

	$cmd_search_host = dirname(__FILE__)."/check_dns -H ".$host." -t 1 -s ".$server_zone." -A -q ns" ;
	if(isset($dd)) var_dump($cmd_search_host);
	$resp_cmd_search_host = exec($cmd_search_host, $foo , $exit_code_cmd_search_host);
	if(isset($dd)) var_dump($resp_cmd_search_host);

	$auth = array();

	if($exit_code_cmd_search_host == 0){
		$pattern = '/returns\s(.*)\|.*=(.*)s/';
		preg_match($pattern, $resp_cmd_search_host, $res_out);

		$auth['nameservers'] = explode(',', $res_out[1]);
		$auth['time'] = $res_out[2];
		$auth['code'] = 0;
	}else{//sem erro, faz parse e guarda a info de time
		$auth['nameservers'] = array();
		$auth['time'] = 0;
		$auth['code'] = 2;		
	}	
	return $auth;
}

function getNameserversByExternal($host, $dd = null){
	//Buscar array de name server principal de acirdo com o ultimo antes do autotitativo

	//separar o host para buscar o name server principal
	$arr_parse_host = explode(".",$host);

	//No root a qual nameserver ele responde
	$cmd_nsl_1 = exec("nslookup -q=ns .", $out_nsl01 , $code_h_1);
	if(isset($dd)) var_dump("nslookup -q=ns .");

	$arr_nameserver = get_nameserver($out_nsl01, $dd);

	if(isset($dd)) var_dump($arr_nameserver);

	// exemplo ['br','com','interop']
	
	//var_dump($arr_parse_host_reverse);

	
	$i = 0;
	$continua = false;
	do{
		$arr_parse_host_reverse = array_reverse($arr_parse_host);
		$server = "";

		$server_zone = $arr_nameserver[$i];
		$arr_resut_nameservers = array();
		//busca recursiva pelo nameserver

		foreach ($arr_parse_host_reverse as $parse_host) {
			$out_nsl_foreach = array();
			$server = $parse_host.".".$server;
			
			if(isset($dd)) var_dump("nslookup -q=ns ".$server." ".$server_zone);
			$cmd_nsl_1 = exec("nslookup -q=ns ".$server." ".$server_zone, $out_nsl_foreach , $code_nsl);
			
			//var_dump($code_nsl); sleep(3);
			if($code_nsl > 0 ){
				$continua = true;
				if(count($arr_nameserver) -1 == $i) {
					quit("Unknown NS",3);
				}
				break;

			}else{
				$continua = false;
				$arr_resut_nameservers = get_nameserver($out_nsl_foreach, $arg['v']);
				$server_zone = $arr_resut_nameservers[0];
			}
			

		}
		$i++;
	}while( $continua );

	$arr_nameserver_external = $arr_resut_nameservers;
	return $arr_nameserver_external;
}

function verifySoa($zona, $nameservers, $dd = null) {
	//Somente em name servers autoritativos
	if(isset($dd))  var_dump($nameservers);

	foreach ($nameservers as $key => $value) {
		
		if ($value['code'] != 0) {
			unset($nameservers[$key]);
		}
	}
	//var_dump($nameservers);

	if ( count($nameservers) < 2 ) {
		quit('SOA Inconsistent - No Nameservers found',2);
	}else{
		$nameservers = array_keys($nameservers);
	}
	if(isset($dd))  var_dump("Verify SOA:");
	if(isset($dd))  var_dump($nameservers);

    $arr_soa = array();
    $foo = array();
    
    $ret_out = array();
    
    foreach ($nameservers as $key => $nameserver) {
    	//var_dump($nameserver);
    	$out = "";
    	$propiedades = array();
		
		if(isset($dd))  var_dump("nslookup -q=soa $zona $nameserver");
    	$cmd = exec("nslookup -q=soa $zona $nameserver ", $out , $code);
    	unset($out[0], $out[1], $out[2], $out[3], $out[11]);
    	$new_out = array();
    	foreach ($out as $k => $v) {
    		$v = str_replace(" ", "", $v);
    		$v = trim($v);
    		$new_out[] = $v;
    	}
    	$string_out = implode(";", $new_out);
    	
    	$ret_out[$key]['nameserver'] = $nameserver;
    	$ret_out[$key]['string_out'] = $string_out;
    	$ret_out[$key]['soa'] = $new_out;

    	if(isset($dd)) var_dump($new_out);
    	if(count($new_out) < 1 ){
    		quit("SOA Inconsistent - no Info ".$nameserver, 2);
    	}
    	
    }
    //var_dump($ret_out);

    $msg_soa = "";
    $n_erro_soa = 0;
    $first_ret_out = array_shift($ret_out);
	//var_dump($ret_out);
	//$first_ret_out['soa'][6] = "expire=1209601";
	//$first_ret_out['soa'][5] = "minimum=36100";

    $total_erros = 0;
    $msg_arr_first = implode(";",$first_ret_out['soa']);
    $msg_erro = $first_ret_out['nameserver']." #".$msg_arr_first." != ";
    $msg_erro_info = " - ";
    foreach ($ret_out as $key => $value) {
    	$arr_diff =  array_diff($value['soa'], $first_ret_out['soa'] );
    	if(isset($dd)) var_dump($arr_diff);
    	if(count($arr_diff)){
    		$total_erros = $total_erros + count($arr_diff);
    		$erro = 2;
    		$msg_erro .= $value['nameserver']." #";

    		if(isset($dd)) var_dump($arr_diff);
    		$msg_erro .= implode(";",$arr_diff);
    		$msg_erro .= " != ";
    	}
    }

    $perf_data = " | 'errors'=".$total_erros.";;;0; ";

    if($erro) {
    	$msg = $msg_erro.$perf_data;
    	$msg = str_replace(" !=  |", " |", $msg);

		quit('SOA Inconsistent '.$msg,2);		
	}else{
		quit('SOA OK between all Name Servers '.$msg.$perf_data,0);
	}
}

function get_nameserver($arg_array, $dd = null){
	$matches = array();
	foreach($arg_array as $v) {
		if(preg_match("/nameserver = (.*)/i", $v, $m_ns)) {
			//var_dump($m_ns);
			$matches[] = $m_ns[1];
		}
	}
	//RETONA NAMESERVERS;
	if(isset($dd))  var_dump($matches);
	return $matches;
}

function help() {
	$basename = str_replace(".php", "", basename($_SERVER[PHP_SELF]));
	$texto = " Version 2.1
./$basename ... 
	-H HOST
	-v Verbose
	-w thresholds warnning
	-c thresholds critical
	-m Mode:
		a - Check recursively if all NS respond authoritatively to a given DNS zone
		n - Check recursively if exist 2 or more NS servers of a given DNS zone
		r - Check if parent NS records match NS records from the authoritative server. (Stealth NS Check)
		s - Compare SOA registry between all authoritative NS of a given zone.";

	quit($texto, 3);	
}

function get_options() {
	$shortopts  = "H:m:w:c:vh";
	$options = getopt($shortopts);
	if(count($options) < 2 || isset($options['h'])) help();

	$arr_mode = array('a', 'n' ,'r', 's');
	if(!in_array($options['m'], $arr_mode)){
		echo "Use parameter -m according to the help\n";
		help();

	}
	return $options;

}

function quit($text, $code) {
    echo $text."\n";
    exit($code);
}

function metric($value, $warn, $crit) {
	if($warn < $crit){

		if ($value >= $crit) {
		    return 2;
		}else if ($value >= $warn) {
	        return 1;
		}else if ($value < $warn) {
	        return 0;
		}else {
		    $this->quit("Unable to check.",3);
		}
  	}else if ($warn >= $crit){

		if ($value <= $crit) {
		   	return 2;
		}else if ($value <= $warn) {
	       	return 1;
		}else if ($value > $warn) {
	       	return 0;
		}else {
		   	$this->quit("Unable to check.",3);
		}
  }  
}

main();
?>
