#!/usr/bin/php
<?php
include "/usr/local/opmon/etc/config.php";

$mod = "EXTERNAL";
set_logged_user("opmonadmin");

function main() {

	$options = getopt("s:i:d:h");

	if (isset($options['h']))
		usage();

	if (!isset($options['s']) && !isset($options['i']))
		usage();

	$myscat = false;
	if (isset($options['s'])) {
		$myscat = get_scat_by_name($options['s']);
	} else if (isset($options['i'])) {
		if (! is_numeric($options['i'])) {
			print "Invalid ID".PHP_EOL;
			exit(UNKNOWN);
		}
		$myscat = get_scat_by_id($options['i']);
	}

	if ($myscat == false) {
        print "Unable to locate service catalog";
		exit(UNKNOWN);
    }

	$exit_code = $myscat->getStatusForMonitoring();


    if (count($myscat->levels) == 0) {
        print "Catálogo sem elementos.\n";
		exit(OK);
    }

	if ($exit_code == OK) {
		print "Servico do catalogo em funcionamento normal.\n";
		exit(OK);
	}


	$plugin_output = "%d elementos do servico com problema: %s\n";
	$prbl_elems = 0;
	$problems = array();
	foreach($myscat->levels as $level => $elements) {
		foreach($elements as $e) {
			if ($e->service_id === null) { // scat inside scat
				$s = get_scat_by_id($e->host_id);
				if ($s === false) {
					$problems[] = "Unable to locate service catalog by id $e->host_id";
				}
			} else {
				$s = get_service_by_id($e->host_id,$e->service_id);
				if ($s === false) {
					$problems[] = "Unable to locate service({$e->host_id},{$e->service_id})";
				}
			}

			$status = $s->get_status();
			if ($e->service_id === null) { // scat inside scat
				$state = $status;
				$desc = "{$s->name}";
			} else {
				$state = $status->state;
				$desc = "{$status->host_name}({$status->description})";
			}

			/* Alteracao Interop */
			if ($options['d'] == 1) {
				if ($state != OK && $status->scheduled_downtime_depth == 1 ) {
					$state = OK;
					$desc .= " Com Parada Agendada";
					$exit_code = 0;
				}
			} elseif ($options['d'] == 2) {
				if ($state != OK && $status->scheduled_downtime_depth == 1 ) {
					$state = WARNING;
					$desc .= " Com Parada Agendada";
					$exit_code = 1;
				}
			}
			/* Fim alteração Interop */

			if ($state != OK ) {
				$prbl_elems++;
				switch($state) {
    				case WARNING:
	    				$desc .= " WARNING";
		    			break;

			    	case CRITICAL:
				    	$desc .= " CRITICAL";
					    break;

    				default:
	    				$desc .= " UNKNOWN";
		    			break;
			    }
				$problems[] = $desc;
			}
		}
	}

	if ($exit_code == OK) {
		print "Servico do catalogo em funcionamento normal.\n";
		exit(OK);
	}

	print sprintf($plugin_output, $prbl_elems, implode(",",$problems));
	exit($exit_code);
}

function usage() {
	print "Usage: ./check_scat_status.php [-s <scat name>] [-i <scat id>] [-d [1|2]]\n";
	print "\t -d 1 - Force scheduled downtimes as OK \n";
	print "\t -d 2 - Force scheduled downtimes as WARNING \n";
	exit(UNKNOWN);
}

main();

?>
